<?php

namespace v2\Models;

use  Filters\Traits\Filterable;
use Illuminate\Database\Capsule\Manager as DB;
use Illuminate\Database\Eloquent\Model as Eloquent;
use User;

class Api extends Eloquent
{

    use  Filterable;

    protected $fillable = [
        'api_key',
        'name',
        'user_id',
        'details',
        'status',
    ];


    protected $table = 'apis';

    public function is_enabled()
    {
        return $this->status == 1;
    }


    public function user()
    {
        return $this->belongsTo(User::class, 'user_id');
    }


    public function getDetailsAttribute($value)
    {
        if ($this->value == null) {
            return [];
        }

        return json_decode($this->value, true);
    }


    public function scopeEnabled($query)
    {
        return $query->where('status', 1);
    }


    public function getActiveStatusAttribute()
    {
        if ($this->status ==1) {
            $label = '<span class="badge badge-success">Enabled</span>';
        } else {
            $label = '<span class="badge badge-danger">Disabled</span>';
        }

        return $label;
    }
}
