<?php


namespace v2\Models;

use v2\Classes\_22Bet\_22Bet;
use v2\Classes\Bet9ja\Bet9ja;
use v2\Classes\Betika\Betika;
use v2\Classes\Betway\Betway;
use v2\Classes\Melbet\Melbet;
use v2\Classes\Msport\Msport;
use v2\Classes\Bangbet\Bangbet;
use v2\Classes\Betking\BetKing;
use v2\Classes\Nairabet\Nairabet;
use v2\Classes\One1xbet\One1xbet;
use v2\Classes\Paripesa\Paripesa;
use v2\Classes\Betwinner\Betwinner;
use v2\Classes\Sportybet\Sportybet;
use v2\Classes\Livescorebet\Livescorebet;
use Illuminate\Database\Eloquent\Model as Eloquent;
use v2\Classes\DbBet\DbBet;
use v2\Classes\Helabet\Helabet;
use v2\Classes\MegaPari\MegaPari;
use v2\Classes\Odibet\Odibet;
use v2\Classes\Wazobet\Wazobet;

class BookMaker extends Eloquent
{

	protected $fillable = [
		'name',
		'key_name',
		'country_id',
		'details',
		'status',
	];


	protected $table = 'bookmakers';

	/**
	 * Register all fetchers. The key is the keyname 
	 *
	 * @var array
	 */
	public static $book_register = [
		'betking' => [
			'fetcher' => BetKing::class,
			'group' => 'betking',
		],

		'bet9ja' => [
			'fetcher' => Bet9ja::class,
		],
		'sportybet' => [
			'fetcher' => Sportybet::class,
			'group' => 'sportybet',
		],
		'1xbet' => [
			'fetcher' => One1xbet::class,
			'group' => '1xbet',
		],

		'22bet' => [
			'fetcher' => _22Bet::class,
			'group' => '1xbet',
		],
		'melbet' => [
			'fetcher' => Melbet::class,
			'group' => '1xbet',
		],
		'paripesa' => [
			'fetcher' => Paripesa::class,
			'group' => '1xbet',
		],
		'msport' => [
			'fetcher' => Msport::class,
			'group' => 'sportybet',
		],
		'bangbet' => [
			'fetcher' => Bangbet::class,
			'group' => 'sportybet',
		],
		'nairabet' => [
			'fetcher' => Nairabet::class,
		],
		'betwinner' => [
			'fetcher' => Betwinner::class,
			'group' => '1xbet',
		],
		'megapari' => [
			'fetcher' => MegaPari::class,
			'group' => '1xbet',
		],
		'helabet' => [
			'fetcher' => Helabet::class,
			'group' => '1xbet',
		],
		'double_bet' => [
			'fetcher' => DbBet::class,
			'group' => '1xbet',
		],
		'livescorebet' => [
			'fetcher' => Livescorebet::class,
		],

		'betway' => [
			'fetcher' => Betway::class,
			'group' => 'sportybet',
		],
		'betika' => [
			'fetcher' => Betika::class,
			'group' => 'sportybet',
		],
		'odibet' => [
			'fetcher' => Odibet::class,
			'group' => 'sportybet',
		],
		'wazobet' => [
			'fetcher' => Wazobet::class,
			'group' => 'sportybet',
		],
	];



	public function scopefindByKeyName($query, $key_name, $column = 'name')
	{
		return $query->where($column, $key_name);
	}



	public function getRegisteredClass()
	{
		return self::$book_register[$this->NameKey];
	}

	public function getNameKeyAttribute()
	{
		if ($this->key_name == null) {

			return strtolower(str_replace(' ', '', $this->name));
		} else {
			return $this->key_name;
		}
	}


	public function getDetailsArrayAttribute()
	{
		if ($this->details == null) {
			return [];
		}

		return json_decode($this->details, true);
	}
}
