<?php

$balance_bf = ($transactions->first()->formattedPriorBalance ?? 0);

include 'inc/headers.php'; ?>

<div class="row">
    <div class="col-sm-8">
        <h3><?= $chart_of_account->account_name; ?></h3>
        <small><?= $chart_of_account->owner->DropSelfLink ?? ''; ?></small>
        <small> <?= $note; ?></small>
        <br>
        <small><?= (date("M j, Y", strtotime($from))); ?> to <?= (date("M j, Y", strtotime($to))); ?> </small>
    </div>
    <!-- Modal -->
    <div id="customise_report" class="modal fade " style="display: ;" role="dialog">
        <div class="modal-dialog">

            <!-- Modal content-->
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                    <h4 class="modal-title">Customise Report</h4>
                </div>
                <div class="modal-body">
                    <form id="customise_report" action="<?= domain; ?>/accounts/set_account_transaction_filters/<?= $chart_of_account->id; ?>">

                        <div class="form-group">
                            <label>From</label>
                            <input type="date" value="<?= $from; ?>" name="from" class="form-control">
                            <label>To</label>
                            <input type="date" name="to" value="<?= $to; ?>" class="form-control">
                        </div>


                        <div class="form-group">
                            <label>Per Page</label>
                            <input type="number" value="<?= $per_page; ?>" name="per_page" class="form-control">

                        </div>


                        <div class="modal-footer">
                            <button type="submit" class="btn btn-danger">Submit</button>
                            <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>





    <div class="col-sm-4 text-right">
        <div class="btn-group">
            <div class="btn-group">

                <button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown">
                    Export As <span class="caret"></span></button>
                <ul class="dropdown-menu" role="menu">
                    <li>
                        <a href="<?= domain; ?>/accounts/export_transaction_to_pdf/<?= $chart_of_account->id; ?>">PDF
                        </a>
                    </li>

                    <li>
                        <a href="<?= domain; ?>/accounts/export_transaction_to_csv/<?= $chart_of_account->id; ?>">CSV
                        </a>
                    </li>

                </ul>
                <button type="button" class="btn btn-default" data-toggle="modal" data-target="#customise_report">
                    <i class="fa fa-cog"></i> Customise Report
                </button>
            </div>
        </div>

    </div>
</div>

<hr>
<table id="charts_of_accounts_table" class="table table-hover">
    <thead>
        <tr>
            <th>REF</th>
            <th>DESCRIPTION</th>
            <th>DEBITS</th>
            <th>CREDITS</th>
            <th>BALANCE</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td></td>
            <td>Balance B/F</td>
            <td></td>
            <td></td>
            <td><?= ($balance_bf); ?></td>

        </tr>
        <?php


        foreach ($transactions as  $transaction) :
            $second_leg = $transaction->get_second_leg();
        ?>
            <tr>
                <td><?= $transaction->journal_id; ?></td>
                <td><strong><?= $second_leg->chart_of_account->account_name; ?></strong>
                    <br><?= $transaction->description; ?>
                </td>
                <td> <?= MIS::money_format($debits[] = $transaction->debit ?? 0); ?></td>
                <td><?= MIS::money_format($credits[] = $transaction->credit ?? 0); ?></td>
                <td> <?= $transaction->formattedPostBalance; ?></td>

            </tr>
        <?php endforeach; ?>

        <tr>
            <td colspan="2" class="text-center"><strong>Total</strong></td>
            <td><?= MIS::money_format(array_sum($debits ?? [])); ?></td>
            <td><?= MIS::money_format(array_sum($credits ?? [])); ?></td>
            <td></td>

        </tr>
    </tbody>
</table>



<div>
    <nav class="pagination">
        <?= $this->pagination_links($total_transactions, $per_page); ?>
    </nav>
</div>


<?php include 'inc/footers.php'; ?>