<?php

use v2\Classes\ExchangeRate;

$code = Config::currency('code');
$exchange = new ExchangeRate;

//conversion
$priced_currency = $game['currency'] ?? 'USD';
$conversion = $exchange->setFrom($priced_currency)
    ->setTo($code)
    ->setAmount($game['cost'])
    ->getConversion();
$display_price = $conversion['destination_value']; ?>


<div class="card ht-md-100p">
    <div class="card-header d-flex justify-content-between">
        <h6 class="lh-5 mg-b-0"> <?= $ad->paper->name; ?> </h6>
        <a href="#" class="tx-12 link-03">
            <!-- By <?= $ad->editor->firstname; ?>  -->
            <?= count($game['games']); ?> entries <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-arrow-right wd-15 ht-15">
                <line x1="5" y1="12" x2="19" y2="12"></line>
                <polyline points="12 5 19 12 12 19"></polyline>
            </svg>
        </a>
    </div>
    <div class="card-body pd-0">
        <ul class="list-unstyled mg-b-0">
            <li class="list-label">
                <!-- <span class="badge badge-success"><?= $ad->bookmaker->name; ?></span> -->
                <?= date("M j Y", strtotime($game['period']['date'])); ?>
                <span class="float-right">R<?= $game['round']; ?> cost:<?= $currency; ?><?= $display_price; ?></span>
            </li>

            <?php foreach ($game['games'] as $key => $event) :
                $text_highlight = time() > strtotime($event['item_date']) ? "text-danger" : "";

                $show_key = false;
                if (isset($game['keys']) && $game['keys'] != null) {
                    $show_key = in_array($event['item_id'], $game['keys']);
                }

                $event_date_has_passed = time() > strtotime($event['item_date']);
                if (
                    isset($event['outcome']['win'])
                    && ($event['outcome']['win'] == 1)
                    && $event_date_has_passed
                ) {
                    $has_result = true;
                    $pass = $event['outcome']['win'] == true;
                } else if(isset($game['show_because_of_win']) && $game['show_because_of_win'] == 1){
                    $has_result = true;
                    $pass = true;

                }else{
                    $pass = false;
                    $has_result = false;
                }

                //determine icon
                if ($show_key) {
                    $icon = '<i class="fa fa-key"></i>';
                    $color =  "warning";
                } elseif (@$pass) {
                    $icon = '<i class="fa fa-check-circle"></i>';
                    $color =  "success";
                } elseif (@!$pass) {
                    $icon = '<i class="fa fa-times-circle"></i>';
                    $color =  "danger";
                } else {
                    $icon = '<i class="fa fa-question"></i>';
                    $color =  "info";
                }

                if ($is_delivery) {
                    $icon = '<i class="fa fa-question"></i>';
                }

                $show_line = (isset($reveal) && $reveal == true);
                 ?>
                <li class="list-item ">
                    <?php if ($show_line || $show_key || $has_result) : ?>
                        <!-- <span> -->
                        <div class="media align-items-center">
<!--                             <div class="wd-35 ht-35 bd bd-2 bd-<?= $color; ?> tx-<?= $color; ?> rounded-circle align-items-center justify-content-center op-6 d-none d-sm-flex">
                                <?= $icon; ?>
                            </div>
 -->                            <div class="media-body mg-sm-l-15">
                                <p class="tx-medium mg-b-0"><span class="rounded-circle tx-<?= $color; ?>"><?= $icon; ?></span> <?= $event['item_name']; ?></p>
                                <p class="tx-12 mg-b-0 tx-color-03">
                                    <span><?= $event['category_name']; ?></span> -
                                    <span><?= $event['tournament_name']; ?></span><br>
                                    <!-- code: <?= $event['bet_code']; ?> -->
                                </p>
                                <?php if ($pass) : ?>
                                    <p class="tx-12 mg-b-0 tx-color-03"><span class="badge badge-dark">ft-score:</span>
                                        <?= $event['outcome']['home_score']; ?> - <span><?= $event['outcome']['away_score']; ?></span></p>
                                <?php endif; ?>
                            </div>
                        </div>
                        <div class="text-right tx-rubik">
                            <p class="mg-b-0">
                              <!--   <small class="text-white  badge badge-dark"
                                style="position: absolute;right: 20px" 
                                ><?= ($event['prediction']['category']['type']); ?></small> -->
                                <span class="fa-2x"><?= $event['prediction']['odd']['name']; ?></span>
                                <small class="text-white  badge badge-dark"><?= ($event['prediction']['category']['type']); ?></small>
                                <!-- ~ <?='' //$event['prediction']['odd']['odd_value']; ?>odds -->
                            </p>

                            <p class="tx-12 mg-b-0 tx-success <?= $text_highlight; ?>"> 

                                <?= date("M j Y, H:i", strtotime($event['item_date'])); ?></p>
                        </div>
                        <!-- </span> -->
                    <?php else : ?>
                        Hidden. Purchase to get access.
                    <?php endif; ?>
                </li>
            <?php endforeach; ?>
            <li class="list-label">Booking:N/A <span class="float-right">
                <!-- Total Odds: ~<?='' //round($game['total_odds']); ?></span> -->
            </li>
        </ul>
    </div>
</div>